//-----------------------------------------------------
//	`֘ACu
//	J
//	2010.3.10	TMO
//-----------------------------------------------------
#include "stdafx.h"
#include "Graphic.h"

//쐬ꂽD3DfoCX擾
extern LPDIRECT3DDEVICE9 GetDevice();

void Camera::Select(
		float x, float y, float z,
		float at_x, float at_y, float at_z,
		float top_x, float top_y, float top_z )
{
	m_pos = D3DXVECTOR3(x, y,z);
	m_at  = D3DXVECTOR3(at_x, at_y, at_z);
	m_top = D3DXVECTOR3(top_x, top_y, top_z);

	D3DXMatrixLookAtLH(
	  &m_mat,
	  &(D3DXVECTOR3(x, y,z)),				// J̈ʒu
	  &(D3DXVECTOR3(at_x, at_y, at_z)),		// _̈ʒu
	  &(D3DXVECTOR3(top_x, top_y, top_z))   // J猩̃xNg
	);
	
	GetDevice()->SetTransform( D3DTS_VIEW, &m_mat );
}

void Camera::Rotate( float yaw, float pitch, float roll )
{
	D3DXMATRIX mat;
	D3DXMatrixRotationYawPitchRoll(&mat, yaw,pitch,roll);
	D3DXMatrixMultiply(&m_mat, &m_mat, &mat );
	
	GetDevice()->SetTransform( D3DTS_VIEW, &m_mat );
}

//_ɉ]
void Camera::RotateAtBase( float roty, float rotz )
{
	D3DXVECTOR3 dist;
	dist = m_pos - m_at;
	
	D3DXVECTOR3 world_top(0,1,0);//xNg

	D3DXMATRIX mat;
	D3DXMatrixRotationAxis(&mat, &world_top, roty );

	D3DXVECTOR3 side;
	D3DXVec3Cross( &side, &dist, &m_top );
	side.y = 0;
	D3DXMATRIX mat2;
	D3DXMatrixRotationAxis(&mat2, &side, rotz );
	D3DXMatrixMultiply(&mat, &mat2, &mat );

	D3DXVec3TransformCoord(&dist, &dist, &mat );
	D3DXVec3TransformCoord(&m_top, &m_top, &mat );
	
	m_pos = m_at + dist;

	D3DXMatrixLookAtLH(
	  &m_mat,
	  &m_pos,	// J̈ʒu
	  &m_at,	// _̈ʒu
	  &m_top	// J猩̃xNg
	);
	
	GetDevice()->SetTransform( D3DTS_VIEW, &m_mat );
}

void Camera::Move( float x, float y, float z )
{
	D3DXMATRIX mat;
	D3DXMatrixTranslation( &mat, x, y, z );

	D3DXMatrixMultiply(&m_mat, &m_mat, &mat );

	GetDevice()->SetTransform( D3DTS_VIEW, &m_mat );
}