//-----------------------------------------------------
//	`֘ACu
//	AjȂ
//	2010.03.04 TMO
//-----------------------------------------------------

#include "stdafx.h"
#include "Graphic.h"

CGraphic*				glbl_graphic = NULL;

LPDIRECT3D9				g_pD3D = NULL;			//D3DC^[tF[X D3DfoCX̂ɕKv
LPDIRECT3DDEVICE9		g_pD3DDevice = NULL;	//D3DfoCX `ȂǍL͈͂ŕKvɂȂB

//̃R[h쐬ꂽD3DfoCX擾邽߂̂
extern LPDIRECT3DDEVICE9 GetDevice()
{
	return g_pD3DDevice;
}

//CGraphic̍쐬
CGraphic* CreateGraphic( HWND hWnd )
{
	glbl_graphic = new CGraphic();
	glbl_graphic->Create( hWnd );
	return glbl_graphic;
}

//CGraphic̎擾
CGraphic* GetGraphic() { return glbl_graphic; }

//CGraphic̉
void ReleaseGraphic()
{
	if ( glbl_graphic ) {
		glbl_graphic->Destroy();
		delete glbl_graphic;
		glbl_graphic = NULL;
	}
}

CGraphic::CGraphic()
{
	if ( g_pD3D != NULL ) {
		//CGraphic͂QȂƂɂĂB
		_ASSERT(0);
	}

	m_backColor = 0xFFFFFFFF;

	m_screenWid = 640;
	m_screenHgt = 480;
	m_softwareMode = false;
	m_culling = false;
	m_currDisplayMode = DisplayMode::WindowMode;

	m_RefreshRate = 0;

	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	
	g_pD3DDevice   = NULL;
}
CGraphic::~CGraphic()
{
	Destroy();
}

//CGraphic̍쐬
void CGraphic::Destroy()
{
	if ( m_pVB ) {
		m_pVB->Release();
	}

	//D3DfoCX
	if( g_pD3DDevice )
	{
		g_pD3DDevice->Release();
		g_pD3DDevice = NULL;
	}

	//D3DC^[tF[X
	if( g_pD3D )
	{
		g_pD3D->Release();
		g_pD3D = NULL;
	}
}

bool CGraphic::LoadSetting()
{
	FILE* fp;
	_wfopen_s( &fp, TEXT("setting.txt"), TEXT("r") );
	if ( fp ) {
		WCHAR s[256];
		
		while( fgetws( s, 256, fp ) ) {

			if ( wcscmp(s, TEXT("FULLSCREEN=On\n")) == 0 ) {
				m_currDisplayMode = DisplayMode::FullScreen;
			}

			if ( wcscmp(s, TEXT("SOFTWAREMODE=On\n")) == 0 ) {
				m_softwareMode = true;
			}
			
			if ( wcscmp(s, TEXT("CULLING=On\n")) == 0 ) {
				m_culling = true;
			}
		}

		fclose(fp);
	}

	return true;
}

//`
void CGraphic::SetBlendingDefault()
{
	g_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);	 
	g_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA); 
}

//Z
void CGraphic::SetBlendingAdd()
{
	g_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);	 
	g_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE); 
}

//CGraphic̍쐬( Direct3D̏ )
bool CGraphic::Create(HWND hWnd)
{
	LoadSetting();
	
	{
		//NCAgTCYύXB

		//EBhEg݂ŃTCYw肵
		SetWindowPos( hWnd, NULL, 0, 0, m_screenWid, m_screenHgt, SWP_NOMOVE | SWP_NOZORDER );

		//NCAgTCYwʂɕ␳
		RECT rect;
		GetClientRect( hWnd, &rect );
		int ofsW = m_screenWid - ( rect.right - rect.left );
		int ofsH = m_screenHgt - ( rect.bottom - rect.top );
		SetWindowPos( hWnd, NULL, 0, 0, m_screenWid+ofsW, m_screenHgt+ofsH, SWP_NOMOVE | SWP_NOZORDER );
	}

	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if ( g_pD3D == NULL ) {
		return false;
	}
	
	//D3DPRESENT_PARAMETERS\̏̂߃fBXvC[h擾
	D3DDISPLAYMODE dmode;
	ZeroMemory( &dmode, sizeof( dmode ) );
	g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT , &dmode );
	
	//foCX̏Ԃw肷
	D3DPRESENT_PARAMETERS	d3dpp;
	ZeroMemory( &d3dpp, sizeof( d3dpp ) );

	switch ( m_currDisplayMode ) {
		case DisplayMode::FullScreen:
			//tXN[
			d3dpp.Windowed         = FALSE;
			d3dpp.BackBufferWidth  = m_screenWid;
			d3dpp.BackBufferHeight = m_screenHgt;
			d3dpp.BackBufferFormat = D3DFMT_X8R8G8B8;
			d3dpp.BackBufferCount  = 1;
			d3dpp.SwapEffect       = D3DSWAPEFFECT_DISCARD;
			d3dpp.FullScreen_RefreshRateInHz = 60;
			break;
		case DisplayMode::WindowMode:
			//EBhE[h
			d3dpp.Windowed			= TRUE;
			d3dpp.SwapEffect		= D3DSWAPEFFECT_DISCARD;
			d3dpp.BackBufferFormat	= dmode.Format;
			d3dpp.BackBufferCount	= 1;
			break;
	}
	
	////3D\̐ݒ@Zobt@
	d3dpp.EnableAutoDepthStencil = true;
	d3dpp.AutoDepthStencilFormat = D3DFMT_D16;

	//fBXvCA_v^\߂̃foCX쐬
	//`揈@ƒ_@̓n[hEFAΉłƎŝŁA@̑gݍ킹ςčēx쐬݂
	HRESULT		hr;
	D3DDEVTYPE	devtype;
	DWORD		behaviorFlags;
	for ( int c = 0; c < 4; c++ ) {

		if ( m_softwareMode ) {
			//Ƀ\tgEFA[hŏ
			c = 3;
		}

		switch ( c ) {
            case 0:
				//n[hEFAŕ`揈s
				devtype			= D3DDEVTYPE_HAL;						
				//_n[hEFAōs
				behaviorFlags	= D3DCREATE_HARDWARE_VERTEXPROCESSING;
				break;
			case 1:
				//n[hEFAŕ`揈s
				devtype			= D3DDEVTYPE_HAL;
				//_\tgEFAōs
				behaviorFlags	= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
				break;
			case 2:
				//\tgEFAŕ`揈s
				devtype			= D3DDEVTYPE_REF;
				//_n[hEFAōs
				behaviorFlags	= D3DCREATE_HARDWARE_VERTEXPROCESSING;
				break;
			case 3:
				//\tgEFAŕ`揈s
				devtype			= D3DDEVTYPE_REF;						
				//_\tgEFAōs
				behaviorFlags	= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
				break;
		}
		
		hr = g_pD3D->CreateDevice(
						D3DADAPTER_DEFAULT,
						devtype,
						hWnd,
						behaviorFlags,
						&d3dpp,
						&g_pD3DDevice );
		
		
		if ( FAILED(hr) ) {
			continue;
		}
		break;
	}

	if ( FAILED(hr) ) {
		//\tgEFAɂΉĂȂ
		return false;
	}

	if ( m_culling ) {
		g_pD3DDevice->SetRenderState( D3DRS_CULLMODE, TRUE );
	}

	//At@uh̐ݒ
	g_pD3DDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
	//Lł͎vʂɓ߂Ȃ͂Ȃ̂ŁAufBOW̐ݒsB
	g_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);	 
	g_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA); 

	//eNX`̃At@ɁA|SFAt@Ƃĉݒ
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE );
	g_pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );

	//3D\̐ݒ
	g_pD3DDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
	SetZEnable(TRUE);

	{
		//vWFNV(ˉe)̐ݒ
		double aspect = m_screenWid / m_screenHgt;

		D3DXMATRIX matBaseProj;	
		D3DXMatrixPerspectiveFovLH(
				&matBaseProj,
				(float)(D3DX_PI/4.0),	//p
				(float)aspect,	//AXyNg
				1.0f,               //NbsOi߂قj
				1000000.0f);        //NbsOiق)
				GetDevice()->SetTransform( D3DTS_PROJECTION, &matBaseProj );

		//Cg̐ݒ
		GetDevice()->SetRenderState(D3DRS_LIGHTING,TRUE);
		D3DLIGHT9	light;
		::ZeroMemory(&light, sizeof(D3DLIGHT9));
		light.Type = D3DLIGHT_DIRECTIONAL;
		light.Diffuse.r  = 0.9f;   light.Diffuse.g = 0.9f;   light.Diffuse.b = 0.9f;
		light.Specular.r = 0.2f;  light.Specular.g = 0.2f;  light.Specular.b = 0.2f;
		light.Ambient.r  = 0.5f;   light.Ambient.g = 0.5f;   light.Ambient.b = 0.5f;
		light.Direction = D3DXVECTOR3(0.0f, -0.5f, -0.2f);
		GetDevice()->SetLight(0, &light);
		GetDevice()->LightEnable(0, TRUE);
	}

	//|S̍쐬
	g_pD3DDevice->CreateVertexBuffer(sizeof(D3DVERTEX)*4, 0, D3DFVF_2DVERTEX, D3DPOOL_MANAGED, &m_pVB, NULL );

	// tbV[g̎擾
	ZeroMemory( &dmode, sizeof( dmode ) );
	if ( SUCCEEDED( g_pD3DDevice->GetDisplayMode(0, &dmode) ) ) {
		m_RefreshRate = dmode.RefreshRate;
	} else {
		m_RefreshRate = 0;
	}

	return true;
}

void CGraphic::SetZEnable(BOOL isOn)
{
	g_pD3DDevice->SetRenderState(D3DRS_ZENABLE,isOn? D3DZB_TRUE:D3DZB_FALSE);
	g_pD3DDevice->SetRenderState(D3DRS_ZWRITEENABLE,isOn? TRUE:FALSE);
}
