//-----------------------------------------------------
//	̓Cu
//	2009.12.29 TMO
//-----------------------------------------------------
#include "stdafx.h"
#include "Input.h"
#include "Input_local.h"

CInputMouse*    gl_mouse    = NULL;
CInputKeyboard* gl_keyboard = NULL;
CInputGamepad*  gl_gamepad  = NULL;

HWND					gl_hWnd     = NULL;
IDirectInput8*			gl_pDInput  = NULL;//DirectInputIuWFNg
int						gl_useDevice = 0;//gfoCXiΏۂɂj

//foCX̍쐬
bool LibInputCreate( HWND hWnd, int useDevice )
{
	if ( gl_pDInput ) {
		LibInputRelease();
	}
	gl_hWnd = hWnd;

	//DirectInputIuWFNg̐
	HRESULT hr = DirectInput8Create(::GetModuleHandle(NULL), DIRECTINPUT_VERSION, IID_IDirectInput8, (void**)&gl_pDInput, NULL);
	if ( FAILED( hr ) ) {
		return false;
	}
	
	gl_keyboard = new CInputKeyboard();

	gl_useDevice = useDevice;
	if ( useDevice & UseInputDevice_KEYBOARD ) {
		
		gl_keyboard->Create(gl_pDInput, hWnd);
	}
	if ( useDevice & UseInputDevice_MOUSE    ) {
		gl_mouse = new CInputMouse;
		gl_mouse->Create(gl_pDInput, hWnd);
	}
	if ( useDevice & UseInputDevice_GAMEPAD  ) {
		gl_gamepad = new CInputGamepad();
		gl_gamepad->Create(gl_pDInput, hWnd);
	}
	return true;
}

//͏ԂXV
void LibInputUpdate()
{
	if ( gl_keyboard ) { gl_keyboard->Update(); }
	if ( gl_mouse ) { gl_mouse->Update(); }
	if ( gl_gamepad ) { gl_gamepad->Update(); }
}

//L[{[h͏Ԏ擾
bool ChkKeyDown( int key ){ return gl_keyboard->ChkKeyDown(key); }
bool ChkKeyAction( int key ){ return gl_keyboard->ChkKeyAction(key);}

//Q[pbh͏Ԏ擾
bool ChkGamePadDown(int btn){return gl_gamepad->ChkGamePadDown(btn);}
bool ChkGamePadAction(int btn) {return gl_gamepad->ChkGamePadAction(btn);}

//EBhEvV[W̃}EXbZ[W
void LibInputOperateMouseMessage( UINT message, WPARAM wParam, LPARAM lParam )
{
	if ( gl_mouse ) {
		gl_mouse->OperateMouseMessage(message, wParam, lParam );
	}
}
//}EX͓͏Ԏ擾
long ChkMousePosX() { return gl_mouse->PosX(); }
long ChkMousePosY() { return gl_mouse->PosY(); }
bool ChkMouseLDown(){ return gl_mouse->IsLDown(); }
bool ChkMouseRDown(){ return gl_mouse->IsRDown(); }
bool ChkMouseMDown(){ return gl_mouse->IsMDown(); }
bool ChkMouseLAction(){ return gl_mouse->IsLAction(); }
bool ChkMouseRAction(){ return gl_mouse->IsRAction(); }
bool ChkMouseMAction(){ return gl_mouse->IsMAction(); }


//foCX̉
void LibInputRelease()
{
	//efoCX
	if ( gl_keyboard ) {
		gl_keyboard->Release();
		gl_keyboard = NULL;
	}
	if ( gl_mouse ) {
		gl_mouse->Release();
		gl_mouse = NULL;
	}
	if ( gl_gamepad ) { 
		gl_gamepad->Release();
		gl_gamepad = NULL;
	}

	//DirectInputIuWFNg̉
	if ( gl_pDInput ) {
		gl_pDInput->Release();
		gl_pDInput = NULL;
	}

	gl_hWnd		= NULL;
	gl_useDevice = 0;
}