//-----------------------------------------------------
//	̓Cu
//	Q[pbh
//	2009.12.29 TMO
//-----------------------------------------------------
#include "stdafx.h"
#include "Input.h"
#include "Input_local.h"

CInputGamepad::CInputGamepad()
{
	m_pDIDevJS = NULL;
	ZeroMemory(gamepadState, sizeof(gamepadState));
	ZeroMemory(gamepadAction, sizeof(gamepadAction));
}

//Q[pbhfoCX̍쐬-foCX񋓂̌ʂ󂯎\
struct DIDeviceEnumPrm
{
	bool isFind;
	GUID guid;
};

//Q[pbhfoCX̍쐬-foCX񋓂ăQ[pbhT
static BOOL CALLBACK DIEnumDeviceCallback( LPCDIDEVICEINSTANCE ipddi, LPVOID pvRef )
{
	DIDeviceEnumPrm* prm = (DIDeviceEnumPrm*)pvRef;
	prm->guid   = ipddi->guidInstance;
	prm->isFind = true;

	return DIENUM_STOP;	//񋓂𑱂ȂDIENUM_CONTINUE
}

//Q[pbhfoCX̍쐬
bool CInputGamepad::Create( IDirectInput8* pDInput, HWND hWnd )
{
	HRESULT hr;

	if ( !pDInput ) {
		return false;
	}

	try {
		
		DIDeviceEnumPrm prm;
		prm.isFind = false;
		
		//Q[pbhfoCX񋓂ČGUID擾
		pDInput->EnumDevices( DI8DEVTYPE_JOYSTICK, DIEnumDeviceCallback, (LPVOID)&prm, DIEDFL_ATTACHEDONLY );
		
		if ( prm.isFind != true ) {
			throw "Q[pbh͌܂ł";
		}

		hr = pDInput->CreateDevice( prm.guid, &m_pDIDevJS, NULL );

		if ( FAILED( hr ) ) {
			throw "err";
		}

		m_pDIDevJS->SetDataFormat(&c_dfDIJoystick);

		//[hΒl[h
		DIPROPDWORD diprop;
		ZeroMemory(&diprop, sizeof(diprop));
		diprop.diph.dwSize		= sizeof(diprop);
		diprop.diph.dwHeaderSize = sizeof(diprop.diph);
		diprop.diph.dwObj		= 0;
		diprop.diph.dwHow		= DIPH_DEVICE;
		diprop.dwData			= DIPROPAXISMODE_ABS;
		m_pDIDevJS->SetProperty( DIPROP_AXISMODE, &diprop.diph );
		
		//̒l͈̔͐ݒ
		//\L[ĂȂƂ0ɂȂ悤
		DIPROPRANGE diprg;
		ZeroMemory(&diprg, sizeof(diprg));
		diprg.diph.dwSize		= sizeof(diprg);
		diprg.diph.dwHeaderSize = sizeof(diprg.diph);
		diprg.diph.dwObj		= DIJOFS_X;
		diprg.diph.dwHow		= DIPH_BYOFFSET;
		diprg.lMin = -1000;
		diprg.lMax = 1000;
		m_pDIDevJS->SetProperty( DIPROP_RANGE, &diprg.diph );
		
		diprg.diph.dwObj		= DIJOFS_Y;
		m_pDIDevJS->SetProperty( DIPROP_RANGE, &diprg.diph );
		
		//obt@TCY̐ݒ
		ZeroMemory(&diprop, sizeof(diprop));
		diprop.diph.dwSize = sizeof(diprop);
		diprop.diph.dwHeaderSize = sizeof(diprop.diph);
		diprop.diph.dwObj = 0;
		diprop.diph.dwHow = DIPH_DEVICE;
		diprop.dwData = 1000;
		hr = m_pDIDevJS->SetProperty(DIPROP_BUFFERSIZE, &diprop.diph);
		if ( FAILED( hr ) ) {
			return false;
		}

		//[h̐ݒ
		hr = m_pDIDevJS->SetCooperativeLevel(hWnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
		if (FAILED(hr))
		{
			throw "err";
		}

		//͂
		m_pDIDevJS->Acquire();

	} catch(...) {
		return false;
	}

	return true;
}

//Q[pbh̓͏ԂXVi\L[ƂS̃{^`FbNĂj
void CInputGamepad::Update()
{
	if ( !m_pDIDevJS ) { return; }

	ZeroMemory( gamepadAction, sizeof(gamepadAction) );

	DIDEVICEOBJECTDATA od;
	DWORD dwItems = 1;
	HRESULT hr;
	while ( true ) {
		hr = m_pDIDevJS->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),&od,&dwItems,0);
		
		if ( hr == DIERR_INPUTLOST ) {
			m_pDIDevJS->Acquire();
		} else
		if ( dwItems == 0 || FAILED(hr) ) {
			
			if ( hr == DIERR_NOTACQUIRED ) {
				m_pDIDevJS->Acquire();
			}

			break;
		} else {
		
			switch ( od.dwOfs ) {
				case DIJOFS_X:
					gamepadState[ GamePadBtn_LEFT  ] = false;
					gamepadState[ GamePadBtn_RIGHT ] = false;
					if ( (int)od.dwData < 0 ) {
						gamepadState[ GamePadBtn_LEFT ] = true;
						gamepadAction[ GamePadBtn_LEFT ]= true;
					} else
					if ( (int)od.dwData > 0 ) {
						gamepadState[ GamePadBtn_RIGHT ] = true;
						gamepadAction[ GamePadBtn_RIGHT ]= true;
					}
					break;
				case DIJOFS_Y:
					gamepadState[ GamePadBtn_UP  ] = false;
					gamepadState[ GamePadBtn_DOWN ] = false;
					if ( (int)od.dwData < 0 ) {
						gamepadState[ GamePadBtn_UP ] = true;
						gamepadAction[ GamePadBtn_UP ]= true;
					} else
					if ( (int)od.dwData > 0 ) {
						gamepadState[ GamePadBtn_DOWN ] = true;
						gamepadAction[ GamePadBtn_DOWN ]= true;
					}
					break;
				case DIJOFS_BUTTON0:
					gamepadState[ GamePadBtn_Btn0 ] = ( od.dwData & 0x80 )? true : false;
					
					if ( gamepadState[ GamePadBtn_Btn0 ] ) {
						gamepadAction[ GamePadBtn_Btn0 ]= true;
					}
					break;
				case DIJOFS_BUTTON1:
					gamepadState[ GamePadBtn_Btn1 ] = ( od.dwData & 0x80 )? true : false;
					
					if ( gamepadState[ GamePadBtn_Btn1 ] ) {
						gamepadAction[ GamePadBtn_Btn1 ]= true;
					}
					break;
				case DIJOFS_BUTTON2:
					gamepadState[ GamePadBtn_Btn2 ] = ( od.dwData & 0x80 )? true : false;
					
					if ( gamepadState[ GamePadBtn_Btn2 ] ) {
						gamepadAction[ GamePadBtn_Btn2 ]= true;
					}
					break;
				case DIJOFS_BUTTON3:
					gamepadState[ GamePadBtn_Btn3 ] = ( od.dwData & 0x80 )? true : false;
					
					if ( gamepadState[ GamePadBtn_Btn3 ] ) {
						gamepadAction[ GamePadBtn_Btn3 ]= true;
					}
					break;
			}
		}
	}
}
//Q[pbhfoCX̉
void CInputGamepad::Release()
{
	if ( m_pDIDevJS != NULL ) {
		m_pDIDevJS->Unacquire();
		m_pDIDevJS->Release();
		m_pDIDevJS=NULL;
	}
	ZeroMemory(gamepadState, sizeof(gamepadState));
	ZeroMemory(gamepadAction, sizeof(gamepadAction));

}
