//-----------------------------------------------------
//	̓Cu
//	}EX
//	2009.12.29 TMO
//-----------------------------------------------------
#include "stdafx.h"
#include "Input.h"
#include "Input_local.h"

CInputMouse::CInputMouse()
{
	m_hWnd     = NULL;
	m_pDIMouse = NULL;
	m_posX = 0;
	m_posY = 0;
	m_LDown = false;
	m_RDown = false;
	m_MDown = false;
	m_LAction = false;
	m_RAction = false;
	m_MAction = false;

	m_windowMode = true;
}

//}EXfoCX̍쐬
bool CInputMouse::Create( IDirectInput8* pDInput, HWND hWnd )
{
	HRESULT hr;

	if ( !pDInput ) {
		return false;
	}

	m_hWnd = hWnd;
	RECT rect;
	GetClientRect( m_hWnd, &rect );
	m_wndWid = rect.right - rect.left;
	m_wndHgt = rect.bottom - rect.top;
	m_posX = m_wndWid / 2;
	m_posY = m_wndHgt / 2;

	//}EXfoCX쐬
	hr = pDInput->CreateDevice( GUID_SysMouse, &m_pDIMouse, NULL );
	if ( FAILED( hr ) ) {
		return false;
	}

	//f[^tH[}bg̐ݒ
	hr = m_pDIMouse->SetDataFormat( &c_dfDIMouse2 );
	if ( FAILED( hr ) ) {
		return false;
	}
	
	//obt@TCY̐ݒ
	DIPROPDWORD diprop;
	diprop.diph.dwSize = sizeof(diprop);
	diprop.diph.dwHeaderSize = sizeof(diprop.diph);
	diprop.diph.dwObj = 0;
	diprop.diph.dwHow = DIPH_DEVICE;
	diprop.dwData = 1000;
	hr = m_pDIMouse->SetProperty(DIPROP_BUFFERSIZE, &diprop.diph);
	if ( FAILED( hr ) ) {
		return false;
	}

	//[h̐ݒ
	hr = m_pDIMouse->SetCooperativeLevel( m_hWnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND );
	if ( FAILED( hr ) ) {
		return false;
	}

	//͂
	m_pDIMouse->Acquire();
	
	return true;
}

//}EX̓͏ԂXV
void CInputMouse::Update()
{
	//ZbgB̂߃NbNUpdateMouse()ĂԑOɏȂ΂ȂȂB
	m_LAction = false;
	m_RAction = false;
	m_MAction = false;

	DIDEVICEOBJECTDATA od;
	DWORD dwItems = 1;
	HRESULT hr;
	while ( true ) {
		hr = m_pDIMouse->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),&od,&dwItems,0);
		
		if ( hr == DIERR_INPUTLOST ) {
			m_pDIMouse->Acquire();
		} else
		if ( dwItems == 0 || FAILED(hr) ) {
			
			if ( hr == DIERR_NOTACQUIRED ) {
				m_pDIMouse->Acquire();
			}

			break;
		} else {
			
			switch ( od.dwOfs ) {
				case DIMOFS_X:
					if ( !m_windowMode ) {
						m_posX += (int)od.dwData;
						m_posX = max( 0, min( m_posX, m_wndWid  ) );//EBhE͂ݏoȂ悤
					} else {
						
					}
					break;
				case DIMOFS_Y:
					if ( !m_windowMode ) {
						m_posY += (int)od.dwData;
						m_posY = max( 0, min( m_posY, m_wndHgt ) );
					} else {
					}
					break;
				case DIMOFS_BUTTON0://{^
					m_LDown = ( od.dwData & 0x80 )? true : false;
					if ( m_LDown ) { m_LAction = true; }
					break;
				case DIMOFS_BUTTON1://E{^
					m_RDown = ( od.dwData & 0x80 )? true : false;
					if ( m_RDown ) { m_RAction = true; }
					break;
				case DIMOFS_BUTTON2://{^
					m_MDown = ( od.dwData & 0x80 )? true : false;
					if ( m_MDown ) { m_MAction = true; }
					break;
			}
		}
	}
}


//}EXfoCX̉
void CInputMouse::Release()
{
	if ( m_pDIMouse != NULL ) {
		m_pDIMouse->Unacquire();
		m_pDIMouse->Release();
		m_pDIMouse=NULL;
	}

	m_hWnd = NULL;
	m_posX = 0;
	m_posY = 0;
	m_LDown = false;
	m_RDown = false;
	m_MDown = false;
	m_LAction = false;
	m_RAction = false;
	m_MAction = false;

}